Redmine - Defect #15881

Using Role::PermissionsAttributeCoder makes migration from 1.4 lose role permissions

2014-01-15 22:10 - David Escala

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Permissions and roles Estimated time: 0.00 hour

Target version:

Resolution: Invalid Affected version: 242

Description

In 1.4 permissions are serialized as

- !ruby/sym add_project
- lruby/sym edit_project

and
scan(/: ([a-z0-9_1]+)/) .flatten.map (&:to_sym)

fails to load it. next thing it is saved empty.

History

#1 - 2014-01-19 09:26 - Jean-Philippe Lang
- Status changed from New to Needs feedback

- Resolution set to Cant reproduce

Please read SubmittingBugs. And what was the ruby version that you used with 1.4?

#2 - 2014-01-20 14:12 - David Escala

This is the old environment from which the database is coming from:

Ruby version 1.8.7 (x86_64-1inux)
RubyGems version 1.8.24
Rails version 2.3.17
Database adapter mysql

And this is the target environment:

Redmine version 2.4.2.stable

Ruby version 1.9.3-pl94 (2012-04-20) [x86_64-1inux]
Rails version 3.2.16

Database adapter Mysgl2

In the old environment a Symbol object is serialized as

>> :add_project.to_yaml
=> "——— lruby/sym add_project"

instead of

>> :add_project.to_yaml
=> "——— :add_project\n"

| don't know the reason of this difference, though both are valid YAML representations of a Symbol object.

#3 - 2014-01-23 10:24 - David Escala

My setup is serializing this way because it uses a plugin which replaces YAML with ZAML

To avoid hitting this bug use this patch
https://www.redmine.org/projects/redmine/wiki/SubmittingBugs
http://github.com/hallettj/zaml

—-—— a/app/models/role.rb

+++ b/app/models/role.rb

@@ -58,7 +58,7 Q@ class Role < ActiveRecord: :Base
has_many :members, :through => :member_roles
acts_as_1list

- serialize :permissions, ::Role::PermissionsAttributeCoder
+ serialize :permissions
attr_protected :builtin
validates_presence_of :name
#4 - 2015-03-09 02:37 - Go MAEDA
- Status changed from Needs feedback to Closed

- Resolution changed from Cant reproduce to Invalid

Thanks for providing details.
The cause of the error was plugin, not Redmine core. | close this issue.
